Components.utils.import("resource://tuenti/tuentiAPI.jsm");

var strbundle = Application.storage.get("TuentiStrbundle",null);

var wizard;

function createFriendCheckBox(id,name,img){
    var hbox = document.createElement("hbox");
    var check = document.createElement("checkbox");
    var image = document.createElement("image");
    var spacer = document.createElement("spacer");
    
    hbox.setAttribute("class","friendCheck");
    hbox.setAttribute("fid",id);
    spacer.setAttribute("flex","1");
    check.setAttribute("label",name);
    image.setAttribute("src",img);
    
    var checked = false;
    hbox.addEventListener('click',function(e){
        if(e.target.tagName == 'checkbox')return;
        checked = !checked;
        hbox.setAttribute("checked",checked);
        check.checked = checked;
    },true);
    check.addEventListener("command",function(){
        checked = !checked;
        hbox.setAttribute("checked",checked);
        check.checked = checked;
    },true);
    
    hbox.appendChild(check);
    hbox.appendChild(spacer);
    hbox.appendChild(image);
    
    return hbox;
}
function selectAll(bool){
    var fs = document.getElementById("friendsSelect");
    for(var i = 0, l = fs.childNodes.length; i<l; i++){
        var k = fs.childNodes[i];
        var c = k.getAttribute('checked')=='true';
        c = bool?!c:c;
        if(c){
            var evt = document.createEvent("MouseEvents");
            evt.initMouseEvent("click",true,true,window,0,0,0,0,0,false,false,false,false,0,null);
            k.dispatchEvent(evt);
        }
    }
}


function fillUsers(){
    var fs = mh("#friendsSelect").empty();
    
    var friendNS = Application.prefs.getValue("extensions.tuentifox.datos.nsids","").split(",");
    
    var f = TuentiProxy.friends;
    for each(var k in f){
        if(friendNS.indexOf(k.id + "") >= 0 ) continue;
        fs.append(createFriendCheckBox(k.id,k.nick,k.imgf(30)));
    }
}

var friendsSend = [];
var msgsend = strbundle.getString("invitemsg");

function fillConfirm(){
    
    
    var friendsNames = [];
    var fs = document.getElementById("friendsSelect");
    friendsSend = [];
    
    for each(var k in fs.childNodes){
        if(k.tagName != "hbox" || k.getAttribute("checked")!='true')continue;
        friendsSend.push(k.getAttribute("fid"));
        friendsNames.push(k.firstChild.getAttribute("label"));
    }
    
    if(friendsNames.length == 0){
        alert(strbundle.getString("inviteselectone"));
        wizard.rewind();
    }
    
    mh("#confirmhead").empty().append(document.createTextNode(strbundle.getString("inviteconfirm")));
    mh("#confirmmsg").empty().append(document.createTextNode(msgsend));
    mh("#confirmto").empty().append(document.createTextNode(strbundle.getFormattedString("inviteconfirm2",[friendsNames.join(", ")])));
}
var total = 1;
var curr = 0;
var pro;

function startSend(){
    pro = document.getElementById("prog");
    total = friendsSend.length;
    sendMsg();
    sendMsg();
    sendMsg();   //Enviar los mensajes de tres en tres
}

function updateProgress(){
    pro.setAttribute("value", Math.round(curr*100/total));
    if(curr == total && curr)acabar();
}

function sendMsg(){
    var id = friendsSend.shift();
    if(!id)return;
    
    TuentiProxy.sendPrivateMessage(id,msgsend,function(ok){
        curr++;
        updateProgress();
        if(ok){
            var old = Application.prefs.getValue("extensions.tuentifox.datos.nsids","");
            Application.prefs.setValue("extensions.tuentifox.datos.nsids",old + "," + id);
        }
        sendMsg();
    });
}
var acabado = false;
function acabar(){
    if(acabado)return;
    acabado = true;
    
    wizard.advance(null); //Ir a la siguiente pagina
    
}


function checkConnection(){
    if(TuentiProxy.status >= 2 ){
        fillUsers();
    }else{
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);

        var flags = prompts.BUTTON_TITLE_OK      * prompts.BUTTON_POS_0 +
                    prompts.BUTTON_TITLE_CANCEL  * prompts.BUTTON_POS_1;

        var button = prompts.confirmEx(window, strbundle.getString("noconectedtitle"), strbundle.getString("noconected"), flags, "", "", "", "", {});

        if(button === 0){
            checkConnection();
        }else{
            window.close();
        }
    }
}


window.addEventListener("load",function(e){
    wizard = document.getElementsByTagName("wizard")[0];
    checkConnection();
    
    
},false);

function onClose(){
    if(pro && !acabado){
        var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);

        var flags = prompts.STD_YES_NO_BUTTONS;

        var button = prompts.confirmEx(window, strbundle.getString("noconectedtitle"), strbundle.getString("noclose"), flags, "", "", "", "", {});

        if(button === 0){
            return true;
        }else{
            return false;
        }
    }
    return true;
}

function cancelIfSending(){
    return !(pro && !acabado);
}

function cancelIfSended(){
    return !(pro);
}