/*
 * mh xul framework
 * version  0.1a
 * author: YouWoTMA
 *
 * TODO: insert GPL info
 */

(function(){

 mh = window.mh = function(elm){
        if(!this.mh_ident___)
            return new mh(elm);
        this.init(elm);
  }
mh.fn = mh.prototype = {
    length:0,
    init: function(elm){
        if(!elm)return;
        if(this.isString(elm)){
              elm = this.trim(elm);
              if(/^#([a-z_\-]+)$/i.test(elm))    //optimizacion para mh("#id")
                     this.add(document.getElementById(RegExp.$1));
              else if(/^<([a-z]+)>$/i.test(elm)) //optimizacion para mh("<elm>")
                     this.create(RegExp.$1);
              else
                     this.eacha(document.querySelectorAll(elm),function(k,v){
                         this.add(v);
                     },true);
        }else if(elm.nodeType){
            this.add(elm);
        }else if(this.isMH(elm)){
            for(var i=0,l=elm.length;i<l;i++)this.add(elm[i]);
        }else if(this.isFunction(elm)){
            window.addEventListener("load",elm,false);
        }
    },
    /*Aditional addition methods*/
    parse: function(xul){
        var nodos = new DOMParser().parseFromString('<mh xmlns:html="http://www.w3.org/1999/xhtml" xmlns="http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul">'+xul+"</mh>","text/xml").documentElement.childNodes;
        
        for(var i=0,l=nodos.length;i<l;i++){
            //alert(nodos[i]);
            this._add(nodos[i]);
        }
        return this;
    },
    create: function(tag){
        return this.add(document.createElement(tag));
    },
    fromJSON: function(things){
	return fj(things);
    },
    add: function(){
        return this.eacha(arguments,function(k,v){
            if(this.isString(v))
                this.eacha(document.querySelectorAll(v),function(k,v){
                    this._add(v);
                },true);
            else if(v.nodeType)
                this._add(v);
            else if(this.isMH(v))
                for(var i=0,l=v.length;i<l;i++)this._add(v[i]);
        },true);
    },
    /*Can take *only one* DOM node*/
    _add: function(n){
        this[this.length++] = n;
    },
    /*Transversing*/
    get: function(index){return this[index||0];},
    filter: function(arg){
        if(this.isFunction(arg))
            this.eacha(this,function(k,v){
                if(arg() === false)
                    this.remove(v);
            },true);
    },
    remove: function(index){Array['prototype'].splice.call(this,index,1);},
    remplace: function(index,el){Array['prototype'].splice.call(this,index,1,el);},
    each: function(fn){
        return this.eacha(this,fn);
    },
    eacha: function(object,fn,usemhforcontext){
        var length = object.length;
        if ( length === undefined ) {
	    for ( name in object )
		    if (fn.call(usemhforcontext?this:object[name], name, object[name] ) === false )
			    break;
	}else
	    for ( var value = object[0],i=0; i < length && fn.call(usemhforcontext?this:value, i, value ) !== false; value = object[++i] ){}
        return usemhforcontext?this:object;
    },empty: function(){
        return this.each(function(){while(this.hasChildNodes())this.removeChild(this.firstChild);});
    },getElm: function(el){
		return (el.mh_ident___)?el[0]:el;
       },
	append: function(el){
		el = this.getElm(el);
        return this.each(function(){this.appendChild(el);});
    },appendTo: function(el){
		el = this.getElm(el);
        return this.each(function(){el.appendChild(this);});
    },prepend: function(el){
		el = this.getElm(el);
        return this.each(function(){this.insertBefore(el,this.firstChild);});
    },prependTo: function(el){
		el = this.getElm(el);
        return this.each(function(){el.insertBefore(this,el.firstChild);});
    },before: function(el){
		el = this.getElm(el);
        return this.each(function(){this.parentNode.insertBefore(el,this);});
    },after: function(el){
		el = this.getElm(el);
        return this.each(function(){this.parentNode.insertBefore(el,this.nextSibling);});
    },
    collapse: function(bool){bool = bool||true;return this.attr("collapsed",bool);},
    uncollapse: function(bool){bool = bool||false;return this.attr("collapsed",bool);},
    hide: function(bool){bool = bool||true;return this.attr("hidden",bool);},
    unhide: function(bool){bool = bool||false;return this.attr("hidden",bool);},
    flex: function(n){n = n||0;return this.attr("flex",n);},
    attr: function(a,b){
        var attrs = {};
        if(this.isString(a))
            attrs[a] = b;
        else
            attrs = a;
        
        return this.eacha(attrs,function(k,v){
            this.each(function(){this.setAttribute(k,v);});
        },true);
    },
    css: function(a,b){
        var css = {};
        if(this.isString(a))
            css[a] = b;
        else
            css = a;
        
        return this.eacha(css,function(k,v){
            this.each(function(){this.style[k] = v;});
        },true);
    },
    appendtext: function(txt){
        var domtxt = document.createTextNode(txt);
        return this.each(function(){this.appendChild(domtxt);});
    },
    prependtext: function(txt){
        var domtxt = document.createTextNode(txt);
        return this.each(function(){this.insertBefore(domtxt,this.firstChild);});
    },
    bind: function(event,fn){
        return this.each(function(){this.addEventListener(event,fn,false);});
    },
    trigger: function(event){
        var e = this.createEvent(event);
        return this.each(function(){this.dispatchEvent(e);});
    },
    toggle: function(){
        var togglefn = [],
        toggleindex = 0;
        this.eacha(arguments,function(k,v){
            if(v && this.isFunction(v))togglefn.push(v);
        },true);
        return this.click(function(e){
            togglefn[toggleindex++].call(this,e);
            if(toggleindex == togglefn.length)toggleindex = 0;
        });
    },
    toogle: function(){
        return this.toggle.call(this,arguments);
    },
    addClass: function(clas){
        return this.each(function(){
            for each(var k in this.className.split(/\s+/))
                if(k == clas)return;
            this.className = mh.fn.trim(this.className + " " + clas);
        });
    },
    removeClass: function(clas){
        var regexp = new RegExp("(^|\\s)+" + clas + "(\\s|$)+","g");
        return this.each(function(){
            this.className = mh.fn.trim(this.className.replace(regexp,"$1$2"));
        });
    },
    hasClass: function(clas,el){
        return new RegExp("(^|\\s)+" + clas + "(\\s|$)+","").test((el||this[0]).className);
    },
    toggleClass: function(clas){
        var regexp = new RegExp("(^|\\s)+" + clas + "(\\s|$)+","g");
        this.eacha(this,function(k,v){
            if(this.hasClass(clas,v))
                v.className = v.className.replace(regexp,"$1$2");
            else
                v.className += ((v.className && v.className!="")?" ":"") + clas;
        },true);
    },
    /****utils (some functions are from jQuery)*/
    /**tipo*/
    isString: function(a) {return typeof a == 'string';},
    isFunction: function(a) {return typeof a == 'function';},
    isNull: function(a) {return typeof a == 'object' && !a;},
    isNumber: function(a) {return typeof a == 'number' && isFinite(a);},
    isObject: function(a) {return (typeof a == 'object' && a) || isFunction(a);},
    isArray: function(testObject){return testObject && !(testObject.propertyIsEnumerable('length')) && typeof testObject === 'object' && typeof testObject.length === 'number';},
    isMH: function(a){return a.mh_ident___===true;},
    mh_ident___:true,
    inArray: function( elem, array ) {
            for ( var i = 0, length = array.length; i < length; i++ )
            // Use === because on IE, window == document
                    if ( array[ i ] === elem )
                            return i;

            return -1;
    },
    /*string*/
    trim: function(str){
        return str.replace(/^\s*|\s*$/g,"");
    },
    /*event*/
    createEvent: function(type){
        var e = null;
        switch(type.toLowerCase()){
            case 'blur':case 'focus':
                //UI event
                e = document.createEvent("UIEvents");
                e.initUIEvent(type, true, true, window, 1);
                break;
            case 'keydown':case 'keyup':case 'keypress':
                //key event
                e = document.createEvent("KeyboardEvent");
                e.initKeyEvent(type,true,true,null,false,false,false,false,0,0);
                break;
            case 'click':case 'dblclick':case 'mousedown':case 'mouseup':case 'mousemove':case 'mouseover':case 'mouseout':
                //mouse event
                e = document.createEvent("MouseEvents");
                e.initMouseEvent(type, true, true, window,0, 0, 0, 0, 0, false, false, false, false, 0, null);
                break;
            case 'load':case 'unload':case 'error':case 'select':case 'submit':case 'change':case 'resize':case 'scroll':
                //simple event
                e = document.createEvent("Event");
                e.initEvent(type, true, true);
                break;
        }
        return e;
    }
};


/*Register event helpers (from jQuery)*/
mh.prototype.eacha(("blur,focus,load,resize,scroll,unload,click,dblclick,mousedown,mouseup,mousemove,mouseover,mouseout,mouseenter,mouseleave,change,select,submit,keydown,keypress,keyup,error").split(","),
    function(){
        var e = this;
	mh.prototype[e] = function(fn){
		return fn ? this.bind(e, fn) : this.trigger(e);
	};
});

mhc = window.mhc = function(elm){
	var e = mh().create(elm);
	for(var i=1,l=arguments.lenght;i<l;i++)
		e.append(arguments[i]);
	return e;
}

var fj = window.mhFromJSON = function(UI){
	if(UI.tag && mh.prototype.isString(UI.tag)){
		var m = mh().create(UI.tag);
		if(UI.childs){
			if(m.isArray(UI.childs))
				for each(var k in UI.childs)
					m.append(fj(k)[0]);
			else if(m.isObject(UI.childs))
				m.append(fj(UI.childs)[0]);
			else if(m.isString(UI.childs))
				m.append(document.createTextNode(UI.childs))
		}
		
		if(UI.css)m.css(UI.css);
		if(UI.attr)m.attr(UI.attr);
		if(UI.clase)m.addClass(UI.clase);
		if(UI.txt)m.append(document.createTextNode(UI.childs));
		
		return m;
	}
	return false;
}

})();
